unit KalMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Spin, Grids, ExtCtrls, SRCal, Buttons;

type
  TMainForm = class(TForm)
    CBAstroDaten: TCheckBox;
    ComboBundesland: TComboBox;
    ComboStartTag: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LblDatum: TLabel;
    LblFeiertag: TLabel;
    LblSternzeichen: TLabel;
    LblTagImJahr: TLabel;
    LblWocheImJahr: TLabel;
    LblSunRise: TLabel;
    LblSunSet: TLabel;
    LblSunDist: TLabel;
    LblMoonRise: TLabel;
    LblMoonSet: TLabel;
    LblMoonDist: TLabel;
    LblMoonPhase: TLabel;
    LblMonat: TLabel;
    LblJahr: TLabel;
    PanelAstroDaten: TPanel;
    SpinMonat: TSpinButton;
    SpinJahr: TSpinButton;
    Kalender: TSRCalendar;
    CBDeleteMarks: TCheckBox;
    Label5: TLabel;
    CBShowMarks: TCheckBox;
    CBShowHolidays: TCheckBox;
    LblMoonTransit: TLabel;
    LblSunTransit: TLabel;
    Uhr: TSRClock;
    CBAutoUpdate: TCheckBox;
    EditZeit: TEdit;
    ComboClockStyle: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    ComboClockKind: TComboBox;
    PanelStopWatch: TPanel;
    SBStart: TSpeedButton;
    SBStop: TSpeedButton;
    SBReset: TSpeedButton;
    Label43: TLabel;
    ComboDrawStyle: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure KalenderChange(Sender: TObject);
    procedure SpinMonatDownClick(Sender: TObject);
    procedure SpinMonatUpClick(Sender: TObject);
    procedure SpinJahrDownClick(Sender: TObject);
    procedure SpinJahrUpClick(Sender: TObject);
    procedure ComboBundeslandChange(Sender: TObject);
    procedure CBAstroDatenClick(Sender: TObject);
    procedure ComboStartTagChange(Sender: TObject);
    procedure KalenderDblClick(Sender: TObject);
    procedure CBDeleteMarksClick(Sender: TObject);
    procedure CBShowHolidaysClick(Sender: TObject);
    procedure CBShowMarksClick(Sender: TObject);
    procedure CBAutoUpdateClick(Sender: TObject);
    procedure EditZeitChange(Sender: TObject);
    procedure ComboClockStyleChange(Sender: TObject);
    procedure ComboClockKindChange(Sender: TObject);
    procedure SBStartClick(Sender: TObject);
    procedure SBResetClick(Sender: TObject);
    procedure SBStopClick(Sender: TObject);
    procedure ComboDrawStyleChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.SpinMonatDownClick(Sender: TObject);
begin
  Kalender.PrevMonth;
end;

procedure TMainForm.SpinMonatUpClick(Sender: TObject);
begin
  Kalender.NextMonth;
end;

procedure TMainForm.SpinJahrDownClick(Sender: TObject);
begin
  Kalender.PrevYear;
end;

procedure TMainForm.SpinJahrUpClick(Sender: TObject);
begin
  Kalender.NextYear;
end;

procedure TMainForm.ComboBundeslandChange(Sender: TObject);
begin
  case ComboBundesland.ItemIndex of
    0 : Kalender.Bundesland:=Baden_Wuerttemberg;
    1 : Kalender.Bundesland:=Bayern;
    2 : Kalender.Bundesland:=Berlin;
    3 : Kalender.Bundesland:=Brandenburg;
    4 : Kalender.Bundesland:=Bremen;
    5 : Kalender.Bundesland:=Hamburg;
    6 : Kalender.Bundesland:=Hessen;
    7 : Kalender.Bundesland:=Mecklenburg_Vorpommern;
    8 : Kalender.Bundesland:=Niedersachsen;
    9 : Kalender.Bundesland:=Nordrhein_Westfalen;
   10 : Kalender.Bundesland:=Rheinland_Pfalz;
   11 : Kalender.Bundesland:=Saarland;
   12 : Kalender.Bundesland:=Sachsen;
   13 : Kalender.Bundesland:=Sachsen_Anhalt;
   14 : Kalender.Bundesland:=Schleswig_Holstein;
   15 : Kalender.Bundesland:=Thueringen;
  end;
end;

procedure TMainForm.ComboStartTagChange(Sender: TObject);
begin
  Kalender.StartOfWeek:=ComboStartTag.ItemIndex;
end;

procedure TMainForm.ComboDrawStyleChange(Sender: TObject);
begin
  Kalender.DrawStyle:=TCalendarDrawStyle(ComboDrawStyle.ItemIndex);
end;

procedure TMainForm.CBShowHolidaysClick(Sender: TObject);
begin
  Kalender.ShowHolidays:=CBShowHolidays.Checked;
  LblFeiertag.Caption:=Kalender.Holiday;
end;

procedure TMainForm.CBShowMarksClick(Sender: TObject);
begin
  Kalender.ShowMarks:=CBShowMarks.Checked;
end;

procedure TMainForm.CBDeleteMarksClick(Sender: TObject);
begin
  Kalender.AutoDeleteMarks:=CBDeleteMarks.Checked;
end;

procedure TMainForm.CBAstroDatenClick(Sender: TObject);
begin
  Kalender.AstronomicalData:=CBAstroDaten.Checked;
  PanelAstroDaten.Visible:=CBAstroDaten.Checked;
end;

procedure TMainForm.KalenderDblClick(Sender: TObject);
begin
  Kalender.Marked[Kalender.Day]:=not Kalender.Marked[Kalender.Day];
end;

procedure TMainForm.KalenderChange(Sender: TObject);
begin
  LblMonat.Caption:=LongMonthNames[Kalender.Month];
  LblJahr.Caption:=IntToStr(Kalender.Year);
  LblDatum.Caption:=FormatDateTime('dddd, dd. mmmm yyyy',Kalender.Date);
  LblTagImJahr.Caption:=IntToStr(Kalender.DayOfYear)+'. Tag im Jahr';
  LblWocheImJahr.Caption:=IntToStr(Kalender.WeekOfYear)+'. Woche im Jahr';
  LblFeiertag.Caption:=Kalender.Holiday;
  LblSternzeichen.Caption:='Sternzeichen: '+Kalender.Sternzeichen;
  LblMoonRise.Caption:='Mondaufgang: '+TimeToStr(Kalender.MoonRise)+' h';
  LblMoonTransit.Caption:='Mondhchststand: '+TimeToStr(Kalender.MoonTransit)+' h';
  LblMoonSet.Caption:='Monduntergang: '+TimeToStr(Kalender.MoonSet)+' h';
  LblMoonDist.Caption:='Entfernung zum Mond: '+FloatToStrF(Kalender.MoonDistance,ffNumber,8,0)+' km';
  case Kalender.MoonPhase of
    Neumond   : LblMoonPhase.Caption:='Neumond';
    Vollmond  : LblMoonPhase.Caption:='Vollmond';
    abnehmend : LblMoonPhase.Caption:='Abnehmeder Mond';
    zunehmend : LblMoonPhase.Caption:='Zunehmeder Mond';
  end;
  LblSunRise.Caption:='Sonnenaufgang: '+TimeToStr(Kalender.SunRise)+' h';
  LblSunTransit.Caption:='Sonnenhchststand: '+TimeToStr(Kalender.SunTransit)+' h';
  LblSunSet.Caption:='Sonnenuntergang: '+TimeToStr(Kalender.SunSet)+' h';
  LblSunDist.Caption:='Entfernung zur Sonne: '+FloatToStrF(Kalender.SunDistance/1000000,ffNumber,8,2)+' mio km';
end;

procedure TMainForm.EditZeitChange(Sender: TObject);
begin
  try
    Uhr.Time:=StrToFloat(EditZeit.Text)/24;
  except
  end;
end;

procedure TMainForm.CBAutoUpdateClick(Sender: TObject);
begin
  Uhr.AutoUpdate:=CBAutoUpdate.Checked;
  EditZeit.Enabled:=not CBAutoUpdate.Checked;
end;

procedure TMainForm.ComboClockStyleChange(Sender: TObject);
begin
  case ComboClockStyle.ItemIndex of
    0 : Uhr.Style:=csClassic;
    1 : Uhr.Style:=csDigital;
    2 : Uhr.Style:=csMovingPoints;
    3 : Uhr.Style:=csPieSlice;
  end;
  if Uhr.Style=csDigital then
    Uhr.Height:=65
  else
    Uhr.Height:=130;
end;

procedure TMainForm.ComboClockKindChange(Sender: TObject);
begin
  case ComboClockKind.ItemIndex of
    0 : Uhr.Kind:=ckRealTime;
    1 : Uhr.Kind:=ckStopWatch;
  end;
  PanelStopWatch.Visible:=ComboClockKind.ItemIndex=1;
end;

procedure TMainForm.SBStartClick(Sender: TObject);
begin
  Uhr.Start;
end;

procedure TMainForm.SBStopClick(Sender: TObject);
begin
  Uhr.Stop;
end;

procedure TMainForm.SBResetClick(Sender: TObject);
begin
  Uhr.Reset;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var i : byte;
begin
  for i:=0 to 15 do
    ComboBundesland.Items.Add(Bundeslaender[i]);
  ComboBundesland.ItemIndex:=ord(Kalender.Bundesland);
  for i:=1 to 7 do
    ComboStartTag.Items.Add(LongDayNames[i]);
  ComboStartTag.ItemIndex:=Kalender.StartOfWeek;
  ComboDrawStyle.ItemIndex:=ord(Kalender.DrawStyle);
  ComboClockStyle.ItemIndex:=0;
  ComboClockKind.ItemIndex:=0;
  Kalender.Date:=Date;
end;

end.
